package de.ctdo.bunti.dao;

import java.util.List;

import de.ctdo.bunti.model.BuntiDMXDevice;
import de.ctdo.bunti.model.BuntiDevice;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Repository
public final class BuntiDevicesDAOImpl implements BuntiDevicesDAO {
    private EntityManager em;

    @PersistenceContext
    public void setEntityManager(EntityManager entityManager) {
        this.em = entityManager;
    }

	@Override
	public List<BuntiDMXDevice> getAllDMXDevices() {
        //TODO: hier noch nur die DMX Geräte suchen!
        return em.createQuery("SELECT d FROM BuntiDevice d").getResultList();
	}

    @Override
    public List<BuntiDevice> getAllDevices() {
        return em.createQuery("SELECT d FROM BuntiDevice d").getResultList();
    }
	
	@Override
	public BuntiDevice getDeviceById(int deviceId) {
        return em.find(BuntiDevice.class, deviceId);
	}

    @Override
    public void addDevice(BuntiDevice device) {
        em.persist(device);
    }

    @Override
    public void removeDevice(int deviceId) {
        em.remove(getDeviceById(deviceId));
    }



}
